						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

CreateBitmap_Memory		PROC	hDC:HDC

;	=============================================
;	=== Obtenir les infos relatives  l'image ===
;	=============================================

						push	DIB_RGB_COLORS
						push	OFFSET ImageInfo
						push	NULL
						push	DWord Ptr [Image.bmHeight]
						push	0
						push	DWord Ptr [hImage]
						push	DWord Ptr [hDC]
						call	GetDIBits

						test	eax,eax
						jz		CreateBitmap_Memory_Exit

;	======================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de l'image originale ===
;	======================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory_Exit

						mov		DWord Ptr [lpImageBits],eax

;	======================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de l'image originale ===
;	======================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpWork],eax

;	======================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de l'image originale ===
;	======================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpOriginal],eax

;	=====================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de la tranche ROUGE ===
;	=====================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpRouge],eax

;	=====================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de la tranche VERTE ===
;	=====================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpVert],eax

;	=====================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de la tranche BLEUE ===
;	=====================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpBleu],eax

;	=====================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de la tranche JAUNE ===
;	=====================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpJaune],eax

;	====================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de la tranche CYAN ===
;	====================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpCyan],eax

;	=======================================================================================
;	=== Allouer un bloc de mmoire pouvant contenir tous les bits de la tranche MAGENTA ===
;	=======================================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	DWord Ptr [ImageInfo.bmiHeader.biSizeImage]
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpMagenta],eax

;	=======================================================================
;	=== Allouer un bloc de mmoire pouvant contenir toutes les couleurs ===
;	=======================================================================

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	1000000h * (SIZEOF COLORS_SEARCH)
						push	NULL
						call	VirtualAlloc

						test	eax,eax
						jz		CreateBitmap_Memory

						mov		DWord Ptr [lpdwColors],eax

;	===========================
;	=== Fin de la procdure ===
;	===========================

						xor		eax,eax
						inc		eax

CreateBitmap_Memory_Exit :

						ret
CreateBitmap_Memory		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
