						.Code

WinMain					PROC	hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

;	************************************
;	*** Initialisation des contrles ***
;	************************************

						mov		DWord Ptr Icc.dwSize,SIZEOF INITCOMMONCONTROLSEX
						mov		Icc.dwICC,ICC_ANIMATE_CLASS or ICC_BAR_CLASSES or ICC_COOL_CLASSES or ICC_DATE_CLASSES or ICC_INTERNET_CLASSES or ICC_LINK_CLASS or ICC_LISTVIEW_CLASSES or ICC_PROGRESS_CLASS or ICC_STANDARD_CLASSES or ICC_TAB_CLASSES or ICC_TREEVIEW_CLASSES or ICC_UPDOWN_CLASS or ICC_USEREX_CLASSES

						push	OFFSET Icc
						call	InitCommonControlsEx

;	*************************************************
;	*** Initialisation de la classe de la fentre ***
;	*************************************************

						mov		DWord Ptr [wc.cbSize],SIZEOF WNDCLASSEX
						mov		DWord Ptr [wc.style],CS_HREDRAW or CS_VREDRAW or CS_DBLCLKS or CS_DROPSHADOW
						mov		DWord Ptr [wc.lpfnWndProc],OFFSET WndProc
						mov		DWord Ptr [wc.cbClsExtra],NULL
						mov		DWord Ptr [wc.cbWndExtra],DLGWINDOWEXTRA
						push	DWord Ptr [hInstance]
						pop		DWord Ptr [wc.hInstance]
						mov		DWord Ptr [wc.lpszMenuName],NULL
						mov		DWord Ptr [wc.lpszClassName],OFFSET szClassName

;		=== Crer une brosse propre au programme ===

						push	008000h						; Rouge = 0, Vert = 128, Bleu = 0 
						push	OFFSET $ + 10
						jmp		CreateSolidBrush			; Cration d'une brosse 'VERT FONCE'

						mov		DWord Ptr [wc.hbrBackground],eax

;		=== Charger l'icne de l'application ===

						push	IDI_APPLICATION				; Icne par dfaut
						push	NULL						; Ne pas prciser d'instance
						push	OFFSET $ + 10				; Car on se sert d'une icne 'Systme'
						jmp		LoadIcon

						mov		wc.hIcon,eax				; Sauver l'icne obtenue
						mov		wc.hIconSm,eax

;		=== Initialiser le pointeur de la souris ===

						push	IDC_ARROW					; Le pointeur de la souris aura la forme d'une flche
						push	NULL						; Ne pas prciser d'instance
						push	OFFSET $ + 10				; Car on se sert d'un curseur 'Systme'
						jmp		LoadCursor

						mov		wc.hCursor,eax				; Sauver le pointeur obtenu

;		=== Enregistrement de la classe ===

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la tranche primaire ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET PrimaireProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szTranchePrimaireClass
						mov		DWord Ptr [wc.cbWndExtra],32

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des couleurs ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET ColorShowProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szColorShowClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des gris ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET GreyScaleProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szGreyScaleClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Arbois ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET ArboisProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szArboisClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Poligny ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET PolignyProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szPolignyClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Souvans ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET SouvansProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szSouvansClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Montigny ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MontignyProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMontignyClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Mouchard ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MouchardProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMouchardClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Mathenay ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MathenayProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMathenayClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Vaudrey ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET VaudreyProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szVaudreyClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Vadans ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET VadansProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szVadansClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Marnoz ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MarnozProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMarnozClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Molamboz ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MolambozProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMolambozClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Marnoz ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET PagnozProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szPagnozClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type MontMalin ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MontMalinProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMontMalinClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Bracon ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET BraconProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szBraconClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Vauxelles ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET VauxellesProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szVauxellesClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Mesnay ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET MesnayProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szMesnayClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Ivory ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET IvoryProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szIvoryClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Grozon ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET GrozonProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szGrozonClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Ornans ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET OrnansProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szOrnansClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Ounans ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET OunansProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szOunansClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Quingey ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET QuingeyProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szQuingeyClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Ornans ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET TourmontProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szTourmontClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Enregistrer la classe pour la la fentre des effets de type Arithmetics ===

						mov		DWord Ptr [wc.lpfnWndProc],OFFSET ArithmeticsEffectsProc
						mov		DWord Ptr [wc.lpszClassName],OFFSET szArithmeticsEffectsClass

						push	OFFSET wc
						push	OFFSET $ + 10
						jmp		RegisterClassEx				; Enregistrer la classe de la bote de dialogue

;		=== Afficher la bote de dialogue ===

						push	NULL						; Pas de paramtres utilisateur
						push	OFFSET WndProc				; Adresse de la procdure de gestion des messages
						push	NULL
						push	DLG_MAIN					; Identifiant de la bote de dialogue dans les ressources
						push	DWord Ptr [hInstance]		; Handle d'instance de l'application
						push	OFFSET $ + 10
						jmp		CreateDialogParam

;		=== Sauver le handle de la fentre ===

						mov		eax,DWord Ptr [hWndMain]	; Sauver le handle de la fentre / Bote de dialogue

;		=== Afficher la fentre ===

						push	eax
						push	OFFSET WinMain_Loop
						push	SW_SHOWNORMAL				; Afficher la fentre dans sa taille par dfaut
						push	eax
						push	OFFSET UpdateWindow			; Forcer l'envoi d'un message 'WM_PAINT'
						jmp		ShowWindow

;	**************************************
;	*** Boucle de gestion des messages ***
;	**************************************

WinMain_Loop :
						push	0
						push	0
						push	NULL
						push	OFFSET msg
						push	OFFSET $ + 10
						jmp		GetMessage					; Rcupration du message

;		===============================================================
;		=== Si GetMessage renvoie la valeur '0' => Fin du programme ===
;		===============================================================

						test	eax,eax						; Fin du programme ?
						jz		WinMain_EndLoop				; Oui

;		======================================
;		=== Traitement normal des messages ===
;		======================================

						push	OFFSET msg
						push	OFFSET WinMain_Loop
						push	OFFSET msg
						push	OFFSET DispatchMessage
						jmp		TranslateMessage 

WinMain_EndLoop :

;	************************
;	*** Fin du programme ***
;	************************

						mov		eax,msg.wParam				; Code de retour dans EAX

						ret
WinMain					ENDP
