;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

						.Data?

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

dwGrey_Red				DWord	?
dwGrey_Green			DWord	?
dwGrey_Blue				DWord	?

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_Work			PROC
						LOCAL	_dVal:DWord
						LOCAL	_dRed:QWord
						LOCAL	_dGreen:QWord
						LOCAL	_dBlue:QWord
						LOCAL	_dCent:QWord
						LOCAL	_dwRed:DWord
						LOCAL	_dwGreen:DWord
						LOCAL	_dwBlue:DWord

						mov		DWord Ptr [_dCent],100
						fild	DWord Ptr [_dCent]
						fst		QWord Ptr [_dCent]

						fild	DWord Ptr [dwGrey_Red]
						fdiv	QWord Ptr [_dCent]
						fst		QWord Ptr [_dRed]

						fild	DWord Ptr [dwGrey_Green]
						fdiv	QWord Ptr [_dCent]
						fst		QWord Ptr [_dGreen]

						fild	DWord Ptr [dwGrey_Blue]
						fdiv	QWord Ptr [_dCent]
						fst		QWord Ptr [_dBlue]

						mov		ebx,DWord Ptr [lpImageBits]
						mov		edx,DWord Ptr [lpWork]
						mov		edi,DWord Ptr [Image.bmHeight]

GreyScale_Work_Loop :

						mov		esi,DWord Ptr [Image.bmWidth]

GreyScale_Work_Loop_1 :

						mov		eax,DWord Ptr [ebx]
						and		eax,0ffh
						mov		DWord Ptr [_dwBlue],eax

						mov		eax,DWord Ptr [ebx]
						shr		eax,8
						and		eax,0ffh
						mov		DWord Ptr [_dwGreen],eax

						mov		eax,DWord Ptr [ebx]
						shr		eax,16
						mov		DWord Ptr [_dwRed],eax

						fild	DWord Ptr [_dwRed]
						fld		QWord Ptr [_dRed]
						fmul
						fld		DWord Ptr [_dwGreen]
						fild	DWord Ptr [_dGreen]
						fmul
						fld		DWord Ptr [_dwBlue]
						fild	DWord Ptr [_dBlue]
						fmul
						fadd
						fadd
						fistp	DWord Ptr [_dVal]

						mov		eax,DWord Ptr [_dVal]
						rol		eax,8
						or		eax,DWord Ptr [_dVal]
						rol		eax,8
						or		eax,DWord Ptr [_dVal]

GreyScale_Work_Loop_0 :

						mov		DWord Ptr [edx],eax

GreyScale_Work_Loop_2 :

						add		ebx,SIZEOF DWord
						add		edx,SIZEOF DWord

						dec		esi
						jnz		GreyScale_Work_Loop_1

						dec		edi
						jnz		GreyScale_Work_Loop

						ret
GreyScale_Work			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_SetTitle		PROC	hWnd:HWND
						LOCAL	szTmp[256]:Byte

						lea		esi,szTmp

						push	DWord Ptr [dwGrey_Blue]
						push	DWord Ptr [dwGrey_Green]
						push	DWord Ptr [dwGrey_Red]
						push	OFFSET szFmtGrayScale_001
						push	esi
						call	wsprintf

						add		esp,20

						push	esi
						push	DWord Ptr [hWnd]
						call	SetWindowText

						ret
GreyScale_SetTitle		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_Initialize	PROC	hWnd:HWND
						LOCAL	hSlider_01:HWND
						LOCAL	hSlider_02:HWND
						LOCAL	hSlider_03:HWND

						INVOKE	GetDlgItem,hWnd,IDC_SLIDER_01
						mov		DWord Ptr [hSlider_01],eax

						INVOKE	GetDlgItem,hWnd,IDC_SLIDER_02
						mov		DWord Ptr [hSlider_02],eax

						INVOKE	GetDlgItem,hWnd,IDC_SLIDER_03
						mov		DWord Ptr [hSlider_03],eax

						push	DWord Ptr [hWnd]
						call	GreyScale_SetTitle

						INVOKE	SendMessage,hSlider_01,TBM_SETRANGE,TRUE,00640000h
						INVOKE	SendMessage,hSlider_02,TBM_SETRANGE,TRUE,00640000h
						INVOKE	SendMessage,hSlider_03,TBM_SETRANGE,TRUE,00640000h

						INVOKE	SendMessage,hSlider_01,TBM_SETPOS,TRUE,dwGrey_Red
						INVOKE	SendMessage,hSlider_02,TBM_SETPOS,TRUE,dwGrey_Green
						INVOKE	SendMessage,hSlider_03,TBM_SETPOS,TRUE,dwGrey_Blue

						INVOKE	SetFocus,hSlider_01

						ret
GreyScale_Initialize	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_Default		PROC	hWnd:HWND

						mov		DWord Ptr [dwGrey_Red],30
						mov		DWord Ptr [dwGrey_Green],59
						mov		DWord Ptr [dwGrey_Blue],11

						push	DWord Ptr [hWnd]
						call	GreyScale_Initialize

						ret
GreyScale_Default		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_Enhanced		PROC	hWnd:HWND

						mov		DWord Ptr [dwGrey_Red],70
						mov		DWord Ptr [dwGrey_Green],70
						mov		DWord Ptr [dwGrey_Blue],5

						push	DWord Ptr [hWnd]
						call	GreyScale_Initialize

						ret
GreyScale_Enhanced		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_Init			PROC	hWnd:HWND

						push	DWord Ptr [hWnd]
						call	GreyScale_Default

						ret
GreyScale_Init			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_Command		PROC	hWnd:HWND,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [wParam]
						and		eax,0000ffffh

						cmp		eax,IDOK
						je		GreyScale_Command_1_1

GreyScale_Command_1 :

						cmp		eax,IDCANCEL
						jne		GreyScale_Command_2

GreyScale_Command_1_1 :

						push	DWord Ptr [wParam]
						push	DWord Ptr [hWnd]
						push	OFFSET GreyScale_Command_Exit
						jmp		EndDialog

GreyScale_Command_2 :

						cmp		eax,IDC_BUTTON_01
						jne		GreyScale_Command_3

						push	DWord Ptr [hWnd]
						push	OFFSET GreyScale_Command_Exit
						jmp		GreyScale_Default

GreyScale_Command_3 :

						cmp		eax,IDC_BUTTON_02
						jne		GreyScale_Command_4

						push	DWord Ptr [hWnd]
						push	OFFSET GreyScale_Command_Exit
						jmp		GreyScale_Enhanced

GreyScale_Command_4 :

GreyScale_Command_Exit :

						ret
GreyScale_Command		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale_HScroll		PROC	hWnd:HWND,wParam:WPARAM,lParam:LPARAM
						LOCAL	dwPosition:DWord

						mov		eax,DWord Ptr [wParam]
						and		eax,0000ffffh

						cmp		eax,SB_PAGERIGHT
						je		GreyScale_HScroll_Right

						cmp		eax,SB_PAGELEFT
						je		GreyScale_HScroll_Right

						cmp		eax,SB_LINELEFT
						je		GreyScale_HScroll_Right

						cmp		eax,SB_LINERIGHT
						je		GreyScale_HScroll_Right

						cmp		eax,SB_THUMBTRACK
						jne		GreyScale_HScroll_Exit

						movzx	eax,Word Ptr [wParam + 2]

GreyScale_HScroll_0 :
						mov		DWord Ptr [dwPosition],eax

						push	DWord Ptr [lParam]
						call	GetMenu

						cmp		eax,IDC_SLIDER_01
						je		GreyScale_HScroll_1

						cmp		eax,IDC_SLIDER_02
						je		GreyScale_HScroll_2

						mov		eax,DWord Ptr [dwPosition]
						mov		DWord Ptr [dwGrey_Blue],eax

						mov		edx,IDC_EDIT_03
						jmp		GreyScale_HScroll_3

GreyScale_HScroll_1 :

						mov		eax,DWord Ptr [dwPosition]
						mov		DWord Ptr [dwGrey_Red],eax

						mov		edx,IDC_EDIT_01
						jmp		GreyScale_HScroll_3

GreyScale_HScroll_2 :

						mov		eax,DWord Ptr [dwPosition]
						mov		DWord Ptr [dwGrey_Green],eax

						mov		edx,IDC_EDIT_02

GreyScale_HScroll_3 :

						push	FALSE
						push	eax
						push	edx
						push	DWord Ptr [hWnd]
						call	SetDlgItemInt

						push	DWord Ptr [hWnd]
						push	OFFSET GreyScale_HScroll_Exit
						jmp		GreyScale_SetTitle

GreyScale_HScroll_Right :

						push	0
						push	0
						push	TBM_GETPOS
						push	DWord Ptr [lParam]
						push	OFFSET GreyScale_HScroll_0
						jmp		SendMessage

GreyScale_HScroll_Exit :

						ret
GreyScale_HScroll		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScaleDlgProc		PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [uMsg]

						cmp		eax,WM_INITDIALOG
						jne		GreyScaleDlgProc_1

							push	DWord Ptr [hWnd]
							call	GreyScale_Init

							xor		eax,eax
							inc		eax
							jmp		GreyScaleDlgProc_Exit

GreyScaleDlgProc_1 :

						cmp		eax,WM_COMMAND
						jne		GreyScaleDlgProc_2

							push	DWord Ptr [lParam]
							push	DWord Ptr [wParam]
							push	DWord Ptr [hWnd]
							push	OFFSET GreyScaleDlgProc_End
							jmp		GreyScale_Command

GreyScaleDlgProc_2 :

						cmp		eax,WM_CLOSE
						jne		GreyScaleDlgProc_3

							push	IDCANCEL
							push	DWord Ptr [hWnd]
							push	OFFSET GreyScaleDlgProc_End
							jmp		EndDialog

GreyScaleDlgProc_3 :

						cmp		eax,WM_HSCROLL
						jne		GreyScaleDlgProc_End

							push	DWord Ptr [lParam]
							push	DWord Ptr [wParam]
							push	DWord Ptr [hWnd]
							push	OFFSET GreyScaleDlgProc_End
							jmp		GreyScale_HScroll

GreyScaleDlgProc_End :

						xor		eax,eax

GreyScaleDlgProc_Exit :

						ret
GreyScaleDlgProc		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScaleWmCreate		PROC	hWnd:HWND
						LOCAL	hTmp:HBITMAP
						LOCAL	hDC:HDC

						push	DWord Ptr [hWnd]
						call	Window_SetDim

						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetDC

						mov		DWord Ptr [hDC],eax

						push	DIB_RGB_COLORS
						push	OFFSET ImageInfo
						push	DWord Ptr [lpWork]
						push	CBM_INIT
						push	OFFSET ImageInfo
						push	DWord Ptr hDC
						push	OFFSET $ + 10
						jmp		CreateDIBitmap

						mov		DWord Ptr [hTmp],eax

						push	DWord Ptr [hDC]
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		ReleaseDC

						push	DWord Ptr [hTmp]
						push	0
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		SetWindowLong

						xor		eax,eax
						ret
GreyScaleWmCreate		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScaleWmPaint		PROC	hWnd:HWND
						LOCAL	hDC:HDC
						LOCAL	hDCMem:HDC
						LOCAL	hBmpOld
						LOCAL	hBmpImage:HBITMAP
						LOCAL	dwNewWidth:DWord
						LOCAL	dwNewHeight:DWord
						LOCAL	rc:RECT
						LOCAL	rc2:RECT
						LOCAL	PsP:PAINTSTRUCT

						lea		eax,PsP

						push	eax
						push	DWord Ptr [hWnd]
						call	BeginPaint 

						mov		DWord Ptr [hDC],eax

						invoke	CreateCompatibleDC,hDC
						mov		DWord Ptr [hDCMem],eax

						push	0
						push	DWord Ptr [hWnd]
						call	GetWindowLong

						mov		DWord Ptr [hBmpImage],eax

						invoke	SelectObject,hDCMem,hBmpImage
						mov		DWord Ptr [hBmpOld],eax

						invoke	GetClientRect,hWnd,ADDR rc

						push	DWord Ptr [hWnd]
						call	Bitmap_Proportions

						mov		DWord Ptr [dwNewWidth],eax
						mov		DWord Ptr [dwNewHeight],edx

						invoke	SetRect,ADDR rc2,0,0,rc.right,rc.bottom

						push	LTGRAY_BRUSH
						call	GetStockObject

						push	eax
						lea		eax,rc2
						push	eax
						push	DWord Ptr [hDC]
						call	FillRect

						invoke	SetStretchBltMode,hDC,COLORONCOLOR

						push	SRCCOPY
						push	DWord Ptr [Image.bmHeight]
						push	DWord Ptr [Image.bmWidth]
						push	0
						push	0
						push	DWord Ptr [hDCMem]
						push	DWord Ptr [dwNewHeight]
						push	DWord Ptr [dwNewWidth]
						push	0
						push	0
						push	DWord Ptr [hDC]
						call	StretchBlt

						invoke	SelectObject,hDCMem,hBmpOld

						lea		eax,PsP

						push	eax
						push	DWord Ptr [hWnd]
						call	EndPaint

						ret
GreyScaleWmPaint		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScaleWmClose		PROC	hWnd:HWND

						push	0
						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		GetWindowLong

						push	eax
						push	OFFSET $ + 10
						jmp		DeleteObject

						push	DWord Ptr [hWnd]
						push	OFFSET $ + 10
						jmp		DestroyWindow

						ret
GreyScaleWmClose		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScaleProc			PROC	USES EBX EDI ESI,hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

						mov		eax,DWord Ptr [uMsg]

						cmp		eax,WM_CREATE
						jne		@F

							push	DWord Ptr [hWnd]
							push	OFFSET GreyScaleProc_Exit
							jmp		GreyScaleWmCreate

@@ :

						cmp 	eax,WM_PAINT
						jne		@F

							push	DWord Ptr [hWnd]
							push	OFFSET GreyScaleProc_Exit
							jmp		GreyScaleWmPaint

@@ :

						cmp		eax,WM_ERASEBKGND
						jne		@F

							xor		eax,eax
							inc		eax
							jmp		GreyScaleProc_End

@@ :

						cmp		eax,WM_CLOSE
						jne		@F


							push	DWord Ptr [hWnd]
							push	OFFSET GreyScaleProc_End
							jmp		GreyScaleWmClose

@@ :

GreyScaleProc_Default :

						push	DWord Ptr [lParam]
						push	DWord Ptr [wParam]
						push	DWord Ptr [uMsg]
						push	DWord Ptr [hWnd]
						push	OFFSET GreyScaleProc_End
						jmp		DefWindowProc

GreyScaleProc_Exit :

						xor    eax,eax

GreyScaleProc_End :

						ret
GreyScaleProc			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

GreyScale				PROC	hWnd:HWND
						LOCAL	hTmp:HWND
						LOCAL	dwWidth:DWord
						LOCAL	dwHeight:DWord

						push	NULL
						push	OFFSET GreyScaleDlgProc
						push	DWord Ptr [hWnd]
						push	DLG_GREY_SCALE
						push	DWord Ptr [hInstance]
						call	DialogBoxParam

						cmp		eax,IDOK
						jne		GreyScale_Exit

						call	GreyScale_Work

						mov		eax,DWord Ptr rcWorkArea.right
						sub		eax,DWord Ptr rcWorkArea.left
						mov		DWord Ptr dwWidth,eax

						mov		eax,DWord Ptr rcWorkArea.bottom
						sub		eax,DWord Ptr rcWorkArea.top
						mov		DWord Ptr dwHeight,eax

						push	NULL
						push	DWord Ptr [hInstance]
						push	NULL
						push	DWord Ptr [hWnd]
						push	DWord Ptr dwHeight
						push	DWord Ptr dwWidth
						push	rcWorkArea.top
						push	rcWorkArea.left
						push	WS_POPUP or WS_CAPTION or WS_VISIBLE or WS_SYSMENU
						push	OFFSET szGreyScaleTitle
						push	OFFSET szGreyScaleClass
						push	0
						call	CreateWindowEx

						mov		DWord Ptr [hTmp],eax

						push	SW_SHOW
						push	DWord Ptr [hTmp]
						call	ShowWindow

						push	DWord Ptr [hTmp]
						call	UpdateWindow

GreyScale_Exit :

						ret
GreyScale				ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
