						.Code

;	OnWmCreate(HWND hWnd,LPRECT lpZoneClient)

;	hWnd			Handle de la fentre en cours de cration
;	lpZoneClient	Taille de la zone client

;	Si la fonction renvoie la valeur 0 dans EAX, alors la fentre ne sera pas cre
;	Si la fonction renvoie la valeur 1 dans EAX, alors la fentre est cre

OnWmCreate				PROC	hWnd:HWND,lpRc:Ptr Rect
						LOCAL	hMenu:HANDLE

;	*********************************************
;	*** Initialiser la structure OPENFILENAME ***
;	*********************************************

						mov		eax,DWord Ptr wc.hInstance
						mov		DWord Ptr [Ofn.lStructSize],SIZEOF OPENFILENAME
						mov		DWord Ptr [Ofn.hInstance],eax								; Handle d'instance
						mov		DWord Ptr [Ofn.lpstrFilter],OFFSET szFileFilters			; Filtres de slection
						mov		DWord Ptr [Ofn.lpstrCustomFilter],NULL
						mov		DWord Ptr [Ofn.nFilterIndex],1
						mov		DWord Ptr [Ofn.lpstrFile],OFFSET szFileName					; Nom du fichier slectionn
						mov		DWord Ptr [Ofn.nMaxFile],SIZEOF szFileName
						mov		DWord Ptr [Ofn.lpstrFileTitle],OFFSET szFileTitle			; Nom du fichier slectionn (Sans le chemin)
						mov		DWord Ptr [Ofn.nMaxFileTitle],SIZEOF szFileTitle
						mov		DWord Ptr [Ofn.lpstrInitialDir],OFFSET szDirectory			; Dossier de dpart
						mov		DWord Ptr [Ofn.lpstrTitle],OFFSET szOpenTitle				; Titre de la bote de dialogue
						mov		DWord Ptr [Ofn.Flags],OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_FORCESHOWHIDDEN or OFN_PATHMUSTEXIST or OFN_ENABLESIZING
						mov		DWord Ptr [Ofn.lpstrDefExt],OFFSET szDefExt

;	*************************************
;	*** Griser les menus des tranches ***
;	*************************************

						push	DWord Ptr [hWnd]
						call	Menus_Disable

;	*** Allouer un bloc de mmoire pour le comptage des couleurs ***

						push	PAGE_EXECUTE_READWRITE
						push	MEM_COMMIT or MEM_RESERVE
						push	01000000h * SIZEOF DWord
						push	NULL
						call	VirtualAlloc

						mov		DWord Ptr [lpdwColors],eax

						test	eax,eax
						jnz		OnWmCreate_Exit

						push	0
						push	0
						push	WM_CLOSE
						push	DWord Ptr [hWnd]
						call	PostMessage

OnWmCreate_Exit :

;	**************************
;	*** Fin de la fonction ***
;	**************************

						xor		eax,eax
						inc		eax
						ret
OnWmCreate				ENDP
