						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Bitmap_Tranches			PROC	USES EDI ESI,hWnd:HWND,hDC:HDC,lpBits:LPBYTE,dwMask:DWord

						mov		edi,DWord Ptr Image.bmHeight
						mov		edx,DWord Ptr lpBits
						mov		ebx,DWord Ptr dwMask

Bitmap_Tranches_Loop :

						mov		esi,DWord Ptr Image.bmWidth

Bitmap_Tranches_Loop_1 :

						mov		eax,DWord Ptr [edx]
						and		eax,ebx
						mov		DWord Ptr [edx],eax
						add		edx,SIZEOF DWord

						dec		esi
						jnz		Bitmap_Tranches_Loop_1

						dec		edi
						jnz		Bitmap_Tranches_Loop

						push	DIB_RGB_COLORS
						push	OFFSET ImageInfo
						push	DWord Ptr [lpBits]
						push	CBM_INIT
						push	OFFSET ImageInfo
						push	DWord Ptr hDC
						call	CreateDIBitmap

						ret
Bitmap_Tranches			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

BmpView_CreateTranches	PROC	USES EBX EDI ESI,hWnd:HWND,hDC:HDC
						LOCAL	szTmp[512]:Byte

						mov		esi,DWord Ptr [hWnd]
						mov		edi,DWord Ptr [hDC]

;	=====================================
;	=== Reset des handles des bitmaps ===
;	=====================================

						mov		DWord Ptr [hOriginal],eax
						mov		DWord Ptr [hRouge],eax
						mov		DWord Ptr [hVert],eax
						mov		DWord Ptr [hBleu],eax
						mov		DWord Ptr [hJaune],eax
						mov		DWord Ptr [hCyan],eax
						mov		DWord Ptr [hMagenta],eax

;	====================================================
;	=== Crer les handles des tranches               ===
;	=== ROUGE, VERTE, BLEUE, JAUNE, CYANT et MAGENTA ===
;	====================================================

						push	0ff0000h
						push	DWord Ptr [lpRouge]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hRouge],eax

						push	0ff00h
						push	DWord Ptr [lpVert]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hVert],eax

						push	0ffh
						push	DWord Ptr [lpBleu]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hBleu],eax

						push	0ffff00h
						push	DWord Ptr [lpJaune]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hJaune],eax

						push	0ff00ffh
						push	DWord Ptr [lpMagenta]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hMagenta],eax

						push	0ffffh
						push	DWord Ptr [lpCyan]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hCyan],eax

						push	-1
						push	DWord Ptr [lpOriginal]
						push	edi
						push	esi
						call	Bitmap_Tranches

						test	eax,eax
						jz		BmpView_CreateTranches_Error

						mov		DWord Ptr [hOriginal],eax

						xor		eax,eax
						inc		eax

						jmp		BmpView_CreateTranches_Exit

BmpView_CreateTranches_Error :

						call	File_FreeMemory

						lea		esi,szTmp

						push	OFFSET szFileTitle
						push	OFFSET szFmtError_001
						push	esi
						call	wsprintf 

						add		esp,12

						push	MB_OK or MB_APPLMODAL or MB_ICONERROR
						push	OFFSET szError
						push	esi
						push	DWord Ptr [hWnd]
						call	MessageBox

						xor		eax,eax

BmpView_CreateTranches_Exit :

						ret
BmpView_CreateTranches	ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
