						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

Bitmap_Proportions		PROC	hWnd:HWND
						LOCAL	dwNewWidth:DWord
						LOCAL	dwNewHeight:DWord
						LOCAL	rc:RECT

						lea		eax,rc

						push	eax
						push	DWord Ptr [hWnd]
						call	GetClientRect 

;	===========================================================
;	=== Si l'image est horizontale (W > H) => H = W / Ratio ===
;	=== Si l'image est verticale   (H > W) => W = H / Ratio ===
;	===========================================================

						mov		eax,DWord Ptr [Image.bmWidth]

						cmp		eax,DWord Ptr [Image.bmHeight]
						jg		Bitmap_Proportions_Horizontale

Bitmap_Proportions_Verticale :

						fild	DWord Ptr [rc.bottom]
						fmul	QWord Ptr [dwImageRatio]

						fist	DWord Ptr dwNewWidth

						mov		eax,DWord Ptr [rc.bottom]
						mov		DWord Ptr [dwNewHeight],eax

						jmp		Bitmap_Proportions_Continue

Bitmap_Proportions_Horizontale :

						fild	DWord Ptr [rc.right]
						fmul	QWord Ptr [dwImageRatio]

						fist	DWord Ptr [dwNewHeight]

						mov		eax,DWord Ptr [rc.right]
						mov		DWord Ptr [dwNewWidth],eax

Bitmap_Proportions_Continue :

						mov		eax,DWord Ptr [dwNewWidth]
						mov		edx,DWord Ptr [dwNewHeight]

						ret
Bitmap_Proportions		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################
