include windows.inc
include user32.inc
include gdi32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include comdlg32.inc
include masm32.inc
include ole32.inc
include oleaut32.inc

include Resource.inc

includelib user32.lib
includelib gdi32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib comdlg32.lib

includelib masm32.lib
includelib ole32.lib
includelib oleaut32.lib

WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD

OFN_FORCESHOWHIDDEN	=	10000000h
OFN_ENABLESIZING	=	00800000h

DLG_MAIN			=	1000

IDM_MENU			=	10000
IDM_OPEN			=	10001
IDM_FILE_EXIT		=	10999
IDM_HELP_ABOUT		=	10101

HIMETRIC_INCH		=	2540

IPicture STRUCT
    ; IUnknown methods
    QueryInterface          DWORD   ?
    AddRef                  DWORD   ?
    Release                 DWORD   ?
    ; IPicture methods
    get_Handle              DWORD   ?
    get_hPal                DWORD   ?
    get_Type                DWORD   ?
    get_Width               DWORD   ?
    get_Height              DWORD   ?
    Render                  DWORD   ?	
    set_hPal                DWORD   ?
    get_CurDC               DWORD   ?
    SelectPicture           DWORD   ?
    get_KeepOriginalFormat  DWORD   ?
    put_KeepOriginalFormat  DWORD   ?
    PictureChanged          DWORD   ?
    SaveAsFile              DWORD   ?
    get_Attributes          DWORD   ?
IPicture ENDS

BitmapFromPicture			PROTO	:DWORD
BitmapFromFile				PROTO	lpszFileName:DWORD
BitmapFromPicture			PROTO	:DWORD

COLORS_SEARCH				STRUCT
	dwColor					DWord	?		; Code de la couleur
	dwCount					DWord	?		; Nombre de rfrences
	dwIndex					DWord	?		; Index de la couleur
	dwRed					DWord	?		; Intensit de rouge
	dwGreen					DWord	?		; Intensit de vert
	dwBlue					DWord	?		; Intensit de bleu
	dwScrCount				DWord	?		; Nombre de rfrences  l'cran
	dwScrIndex				DWord	?		; Index de la couleur  l'cran
COLORS_SEARCH				ENDS

NMLVDISPINFO				STRUCT
	hdr						NMHDR	<>
	item					LVITEM	<>
NMLVDISPINFO				ENDS

GRAY MACRO red, green, blue
        LOCAL rval
        .data
          rval dd 0
          align 4
        .code
        fld8  <red>.0
        fld8  0.30
        fmul
        fld8  <green>.0
        fld8  0.59
        fmul
        fld8  <blue>.0
        fld8  0.11
        fmul
        fadd
        fadd
        fistp rval
        mov   eax, rval
        rol   eax, 8
        or    eax, rval
        rol   eax, 8
        or    eax, rval
        EXITM <eax>
    ENDM
