						.Code

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_DeleteBitmaps		PROC
	
						cmp		DWord Ptr [hImage],NULL
						je		File_DeleteBitmaps_Exit

						push	DWord Ptr [hImage]
						call	DeleteObject

						cmp		DWord Ptr [hOriginal],NULL
						je		@F

						push	DWord Ptr [hOriginal]
						call	DeleteObject

@@ :

						cmp		DWord Ptr [hRouge],NULL
						je		@F

						push	DWord Ptr [hRouge]
						call	DeleteObject

@@ :

						cmp		DWord Ptr [hVert],NULL
						je		@F

						push	DWord Ptr [hVert]
						call	DeleteObject

@@ :

						cmp		DWord Ptr [hBleu],NULL
						je		@F

						push	DWord Ptr [hBleu]
						call	DeleteObject

@@ :

						cmp		DWord Ptr [hJaune],NULL
						je		@F

						push	DWord Ptr [hJaune]
						call	DeleteObject

@@ :

						cmp		DWord Ptr [hCyan],NULL
						je		@F

						push	DWord Ptr [hCyan]
						call	DeleteObject

@@ :

						cmp		DWord Ptr [hMagenta],NULL
						je		File_DeleteBitmaps_Exit

						push	DWord Ptr [hMagenta]
						call	DeleteObject

File_DeleteBitmaps_Exit :

						ret
File_DeleteBitmaps		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_ReleaseMemory		PROC

						cmp		DWord Ptr [lpImageBits],NULL
						je		File_ReleaseMemory_Exit

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpImageBits]
						push	-1
						call	VirtualFreeEx

						cmp		DWord Ptr [lpOriginal],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpOriginal]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpRouge],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpRouge]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpVert],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpVert]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpBleu],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpBleu]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpJaune],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpJaune]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpCyan],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpCyan]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpMagenta],NULL
						je		@F

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpMagenta]
						push	-1
						call	VirtualFreeEx

@@ :

						cmp		DWord Ptr [lpWork],NULL
						je		File_ReleaseMemory_Exit

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpWork]
						push	-1
						call	VirtualFreeEx

						cmp		DWord Ptr [lpdwColors],NULL
						je		File_ReleaseMemory_Exit

						push	MEM_RELEASE
						push	0
						push	DWord Ptr [lpdwColors]
						push	-1
						push	OFFSET File_ReleaseMemory_Exit
						jmp		VirtualFreeEx

File_ReleaseMemory_Exit :

						xor		eax,eax
						inc		eax
						ret
File_ReleaseMemory		ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

File_FreeMemory			PROC

						call	File_DeleteBitmaps
						call	File_ReleaseMemory

						ret
File_FreeMemory			ENDP

;	#########################################################################################################################
;	#########################################################################################################################
;	#########################################################################################################################

