						.Data?

hDCImg					HDC		?
hBmpImgOld				HBITMAP	?
hBmpWork				HBITMAP	?

						.Code

OnWmPaint_1				PROC	USES EDI ESI,hDC:HDC

						xor		eax,eax

						mov		DWord Ptr [hDCImg],eax
						mov		DWord Ptr [hBmpImgOld],eax

;	**********************************************************
;	*** Crer un DC mmoire pour y stocker l'image charge ***
;	**********************************************************

						push	DWord Ptr [hDC]
						call	CreateCompatibleDC

						test	eax,eax
						jz		OnWmPaint_1_Exit

						mov		DWord Ptr hDCImg,eax

;	***************************************
;	*** Slectionner l'image dans le DC ***
;	***************************************

						push	DWord Ptr [hImage]				; Handle de l'image
						push	eax								; Handle du DC rserv  l'image
						call	SelectObject

						test	eax,eax
						jz		OnWmPaint_2_Exit

						mov		DWord Ptr [hBmpImgOld],eax
						jmp		OnWmPaint_1_Exit

OnWmPaint_2_Exit :

						push	DWord Ptr [hDCImg]
						call	DeleteDC

						xor		eax,eax

OnWmPaint_1_Exit :

						ret
OnWmPaint_1				ENDP

OnWmPaint				PROC	USES EBX EDI ESI,hWnd:HWND,hDC:HDC
						LOCAL	dwNewWidth:DWord
						LOCAL	dwNewHeight:DWord
						LOCAL	rc:RECT

;	**********************************************************************
;	*** Si aucune image n'a t slectionne, il ne faut rien dessiner ***
;	**********************************************************************

						cmp		DWord Ptr [hImage],NULL
						je		OnWmPaint_Exit

;	*********************
;	*** Charger le DC ***
;	*********************

						mov		esi,DWord Ptr [hDC]				; hDC

;	*****************************************************
;	*** Charger l'image dans un DC qui lui est propre ***
;	*****************************************************

						push	esi
						call	OnWmPaint_1

						test	eax,eax
						jz		OnWmPaint_Exit					; Impossible d'obtenir un nouveau DC

;	===========================================
;	=== Obtenir la taille de la zone client ===
;	===========================================

						lea		eax,rc

						push	eax
						push	DWord Ptr [hWnd]
						call	GetClientRect

;	==================================================
;	=== Calcul des dimensions de l'image  l'cran ===
;	==================================================

						push	DWord Ptr [hWnd]
						call	Bitmap_Proportions

						mov		DWord Ptr [dwNewWidth],eax
						mov		DWord Ptr [dwNewHeight],edx

						push	COLORONCOLOR
						push	esi
						call	SetStretchBltMode

						push	SRCCOPY
						push	DWord Ptr [Image.bmHeight]
						push	DWord Ptr [Image.bmWidth]
						push	0
						push	0
						push	DWord Ptr [hDCImg]
						push	DWord Ptr [dwNewHeight]
						push	DWord Ptr [dwNewWidth]
						push	0
						push	0
						push	esi
						call	StretchBlt

OnWmPaint_Exit_02 :

						push	DWord Ptr [hBmpImgOld]
						push	DWord Ptr [hDCImg]			; DC Rserv  l'image
						call	SelectObject

OnWmPaint_Exit_01 :

						push	DWord Ptr [hDCImg]			; DC Rserv  l'image
						call	DeleteDC

OnWmPaint_Exit :

						ret
OnWmPaint				ENDP
